

proc done { w } { 
    frame $w.f2
    global Dbhelp Date
    if { ! [info exists Dbhelp(is_dbhelp)] } {
	button $w.f2.dismiss -text Dismiss -command "destroy $w"
	pack $w.f2.dismiss -fill x
    } else {
        button $w.f2.quit -text Quit \
            -bg red -fg white -activebackground red \
            -command "destroy ."

	button $w.f2.dismiss -text Dismiss -command "destroy $w"
	pack $w.f2.quit -side right
	pack $w.f2.dismiss -fill x
    }

    table $w \
	$w.f2 50,0 -columnspan 25 -fill x

    wm resizable $w no no
}

proc dbfield { database table field } { 
    global Dbhelp 
    if { [winfo exists .w_$table$field] } { raise .w_$table$field ; return }
 
    set w .w_$table$field
    toplevel $w
    wm title $w $table.$field
    wm iconname $w dbhelp:$database.$table.$field
 
    set db [dbinvalid]
    set db [dblookup $db $database $table $field dbNULL]
 
    set detail [dbquery $db dbFIELD_DETAIL]
    set desc [dbquery $db dbFIELD_DESCRIPTION]
    set range [dbquery $db dbFIELD_RANGE]
    set format [dbquery $db dbFIELD_FORMAT]
    set size [dbquery $db dbFIELD_SIZE]
    set type [dbquery $db dbFIELD_TYPE]
    set null [dbget $db]
    set index [dbquery $db dbFIELD_INDEX]
    set units [dbquery $db dbFIELD_UNITS]
    set tables [dbquery $db dbFIELD_TABLES]

 
    label $w.w_desc \
	-text $desc \
	-fg blue \
	-font Label \
	-anchor w

    text $w.w_detail \
	-width $Dbhelp(textwidth) \
	-fg blue \
	-font Plain 

    $w.w_detail insert 0.0 $detail
    set nlines [llength [split $detail \n]]
    $w.w_detail configure -state disabled -height $nlines

    global Help
    label $w.w_ltype -text "Field type:"
    regsub db $type "" type
    entry $w.w_type \
	-textvariable Help($w.type) \
	-fg blue \
	-state readonly \
	-relief flat
    set Help($w.type) $type
    label $w.w_lindex -text "First character" 
    entry $w.w_index \
	-textvariable Help($w.index) \
	-fg blue \
	-state readonly \
	-relief flat
    set Help($w.index) $index
    label $w.w_lsize -text "# characters:"
    entry $w.w_size \
	-textvariable Help($w.size) \
	-fg blue \
	-state readonly \
	-relief flat
    set Help($w.size) $size
    label $w.w_lformat -text "printf format:"
    entry $w.w_format \
	-textvariable Help($w.format) \
	-fg blue \
	-state readonly \
	-relief flat
    set Help($w.format) $format
    label $w.w_lnull -text "Null value:" 
    entry $w.w_null \
	-textvariable Help($w.null) \
	-fg blue \
	-state readonly \
	-relief flat
    set Help($w.null) $null
 
    table $w \
        $w.w_desc    3,0 -columnspan 25 -anchor center -fill x \
        $w.w_detail  4,0 -columnspan 25 -anchor center -fill x \
	$w.w_ltype   5,0 -anchor w \
	$w.w_type    5,1 -anchor w \
	$w.w_lsize   6,0 -anchor w \
	$w.w_size    6,1 -anchor w \
	$w.w_lindex  7,0 -anchor w \
	$w.w_index   7,1 -anchor w \
	$w.w_lformat 8,0 -anchor w \
	$w.w_format  8,1 -anchor w \
	$w.w_lnull   9,0 -anchor w \
	$w.w_null    9,1 -anchor w 

    if { "$range" != "" } { 
	label $w.lrange -text Range:
	entry $w.range \
	    -textvariable Help($w.range) \
	    -fg blue \
	    -state readonly \
	    -width [string length $range] \
	    -relief flat
	set Help($w.range) $range
	table $w \
	    $w.lrange   10,0 -columnspan 25 -anchor w \
	    $w.range   10,1 -columnspan 24 -anchor w 
	}
    if { "$units" != "" } { 
	label $w.lunits -text Units: 
	entry $w.units \
	    -textvariable Help($w.units) \
	    -fg blue \
	    -state readonly \
	    -width [string length $units] \
	    -relief flat
	set Help($w.units) $units
	table $w \
	    $w.lunits  11,0 -columnspan 25 -anchor w \
	    $w.units  11,1 -columnspan 24 -anchor w 
	}

 
    label $w.used -text "Used in tables:"
    frame $w.frame

    set maxcol 10
    set i 0
    foreach table [lsort $tables] {
        set col [expr $i % $maxcol]
	set row [expr $i / $maxcol + 10 ]
	
        button $w.frame.w_$table \
            -text $table \
            -anchor w \
            -relief ridge \
            -command "dbtable $database $table"

	set db1 [dblookup $db 0 $table 0 0]
	set defines [dbquery $db1 dbUNIQUE_ID_NAME] 
	if { "$field" == "$defines" } { 
	    $w.frame.w_$table config -fg blue
	    }
 
	table $w.frame $w.frame.w_$table  $row,$col -anchor e -fill x
	incr i
    }
    table $w \
        $w.used  20,0 -columnspan 25 -fill x \
        $w.frame 21,0 -columnspan 25 -fill x

    done $w
}

proc dbtable { database table } { 
    global Dbhelp 

    if { [winfo exists .w_$table] } { raise .w_$table ; return } 

    set w .w_$table
    toplevel $w
    wm title $w $table
    wm iconname $w dbhelp:$database.$table

    set db [dbinvalid]
    set db [dblookup $db $database $table 0 0]

    set fields  [dbquery $db dbTABLE_FIELDS]
    set writeable [dbquery $db dbTABLE_IS_WRITEABLE]
    set dir [dbquery $db dbTABLE_DIRNAME]
    set file [dbquery $db dbTABLE_FILENAME]
    set size [dbquery $db dbTABLE_SIZE]
    set rsize [dbquery $db dbRECORD_SIZE]
    set records 0
    catch {set records [dbquery $db dbRECORD_COUNT]} 
    set detail [dbquery $db dbTABLE_DETAIL]
    set detail [dbquery $db dbTABLE_DETAIL]
    set desc [dbquery $db dbTABLE_DESCRIPTION]
    set primary [dbquery $db dbPRIMARY_KEY]
    set alternate [dbquery $db dbALTERNATE_KEY]
    set foreign [dbquery $db dbFOREIGN_KEYS]
    set defines [dbquery $db dbUNIQUE_ID_NAME]

    label $w.w_desc \
	-text $desc \
	-fg blue \
	-font Label \
	-anchor w

    text $w.w_detail \
	-width $Dbhelp(textwidth) \
	-fg blue \
	-font Plain 

    $w.w_detail insert 0.0 $detail
    set nlines [llength [split $detail \n]]
    $w.w_detail configure -state disabled -height $nlines

    global Help

    label $w.lprimary -text "Primary key: " 
    entry $w.primary \
	-textvariable Help($w.primary) \
	-bg lightblue \
	-state readonly \
	-width [string length $primary] \
	-relief flat
    set Help($w.primary) $primary
    regsub :: $primary " " primary
    append x " " $primary " "
    set primary $x
    unset x

    set maxcol 10 
    set lastcol [expr $maxcol-1]

    table $w \
	$w.w_desc 3,0 -columnspan $maxcol -anchor center -fill x \
	$w.w_detail 4,0 -columnspan $maxcol -anchor center -fill x \
	$w.lprimary   5,0 -anchor w \
	$w.primary    5,1 -anchor w -columnspan $maxcol 

    if { "$alternate" != "" } { 
	label $w.lalternate -text "Alternate key:" 
        entry $w.alternate \
	    -textvariable Help($w.alternate) \
	    -bg paleturquoise \
	    -state readonly \
	    -width [string length $alternate] \
	    -relief flat
	set Help($w.alternate) $alternate
	regsub :: $alternate " " alternate
	append x " " $alternate " "
	set alternate $x
	unset x
	table $w \
	    $w.lalternate   6,0 -anchor w \
	    $w.alternate    6,1 -anchor w -columnspan $maxcol 
    }

    if { "$defines" != "" } { 
	label $w.ldefines -text "Defines id:"  
	entry $w.defines \
	    -textvariable Help($w.defines) \
	    -state readonly \
	    -width [string length $defines] \
	    -relief flat
	set Help($w.defines) $defines
	table $w \
	    $w.ldefines   7,0 -anchor w \
	    $w.defines    7,1 -anchor w 
    }

    if { "$foreign" != "" } { 
	label $w.lforeign -text "Foreign keys:"  
	entry $w.foreign \
	    -textvariable Help($w.foreign) \
	    -fg darkviolet \
	    -state readonly \
	    -width [string length $foreign] \
	    -relief flat
	set Help($w.foreign) $foreign
	table $w \
	    $w.lforeign   8,0 -anchor w \
	    $w.foreign    8,1 -anchor w -columnspan $maxcol
    }

    label $w.w_lrsize -text "Record Size (bytes):"
    entry $w.w_rsize \
	-textvariable Help($w.rsize) \
	-fg blue \
	-state readonly \
	-width [string length $rsize] \
	-relief flat
    set Help($w.rsize) $rsize
    table $w \
	$w.w_lrsize   9,0 -anchor w \
	$w.w_rsize   9,1 -anchor w -columnspan $maxcol

    if { $records > 0 } {
	label $w.w_lsize -text "Size (bytes):"
	entry $w.w_size \
	    -textvariable Help($w.size) \
	    -fg blue \
	    -state readonly \
	    -width [string length $size] \
	    -relief flat
	set Help($w.size) $size

	label $w.lrecords -text Records:
	entry $w.records \
	    -textvariable Help($w.records) \
	    -fg blue \
	    -state readonly \
	    -width [string length $records] \
	    -relief flat
	set Help($w.records) $records

	label $w.lfile -text File:
	entry $w.file \
	    -textvariable Help($w.file) \
	    -fg blue \
	    -state readonly \
	    -width [string length $file] \
	    -relief flat
	set Help($w.file) $file
	if { $writeable > 0 } { 
	    set writeable "may be modified"
	} else { 
	    set writeable "read-only"
	}

	label $w.lwriteable -text Permissions:
	entry $w.writeable \
	    -textvariable Help($w.writeable) \
	    -fg blue \
	    -state readonly \
	    -relief flat
	set Help($w.writeable) $writeable

	table $w \
	    $w.lrecords   10,0 -anchor w \
	    $w.records    10,1 -anchor w -columnspan $maxcol \
	    $w.w_lsize      11,0 -anchor w \
	    $w.w_size       11,1 -anchor w -columnspan $maxcol \
	    $w.lwriteable 12,0 -anchor w \
	    $w.writeable  12,1 -anchor w -columnspan $maxcol \
	    $w.lfile      13,0 -anchor w \
	    $w.file       13,1 -anchor w -columnspan 24 
    }


    set lengths {}
    foreach field $fields { 
	lappend lengths [string length $field] 
    }
    set lengths [lsort -decreasing -integer $lengths]
    set maxcol 0
    set tot 0
    foreach l $lengths { 
	if { [expr $tot + $l] > 60 } { 
	    break 
	}
	incr tot $l
	incr maxcol
    }

    set i 0
    foreach field $fields { 
        set col [expr $i % $maxcol]
        set row [expr $i / $maxcol + 20 ]
        button $w.b_$field \
            -text $field \
            -anchor w \
            -relief ridge \
	    -command "dbfield $database $table $field"

	if { [lsearch $primary $field] >= 0} {
	    $w.b_$field config -bg lightblue
	}
	if { [lsearch $alternate $field] >= 0} {
	    $w.b_$field config -bg paleturquoise
	}
	if { [lsearch $foreign $field] >= 0} {
	    $w.b_$field config -fg darkviolet
	}
        table $w $w.b_$field  $row,$col -anchor e -fill x 
	incr i
    }
    done $w 
}

proc dbhelp { db } { 
    global Dbhelp 

    if { [winfo exists .database] } { 
	wm deiconify .database
	raise .database 
	return 
    }

    set w .database
    toplevel $w
    set database [dbquery $db dbDATABASE_NAME]
    set schema [dbquery $db dbSCHEMA_NAME]
    wm title $w "dbhelp:$schema"
    wm iconname $w dbhelp:$schema
 
    set path [dbquery $db dbDBPATH]
    set name [dbquery $db dbSCHEMA_NAME]
    set detail [dbquery $db dbSCHEMA_DETAIL]
    set desc [dbquery $db dbSCHEMA_DESCRIPTION]
 
    label $w.lname -text Schema:
    label $w.name \
	-text $name \
	-fg blue \
	-font Label \
	-anchor w

    label $w.w_desc \
	-text $desc \
	-fg blue \
	-font Label \
	-anchor w
    set f $w.w_detail
    frame $f
    text $f.text \
	-relief sunken \
	-font Plain \
	-width $Dbhelp(textwidth) \
	-fg blue \
	-bd 2 \
	-yscrollcommand "$f.scroll set" \
	-setgrid 1 \
    	-height 20

    scrollbar $f.scroll -command "$f.text yview"
    pack $f.scroll -side right -fill y
    pack $f.text -expand yes -fill both

    $f.text insert 0.0 $detail
    set nlines [llength [split $detail \n]]
    $f.text configure -state disabled 

    label $w.w_ltype -text "Field type:"
 
    table $w $w.lname  1,0 -anchor center -fill x 
    table $w $w.name    1,1 -columnspan 23 -anchor w -fill x 
    table $w $w.w_desc    3,0 -columnspan 25 -anchor center -fill x 
    table $w $w.w_detail  4,0 -columnspan 25 -anchor center -fill x 

    if { "$path" != "" } { 
	label $w.lpath -text Path:
	label $w.path \
	    -text $path \
	    -fg blue \
	    -anchor w \
	    -font Label 
	table $w \
	    $w.lpath	 2,0 -anchor w -fill x \
	    $w.path	 2,1 -columnspan 24 -anchor w -fill x \
    }

    set ntables [dbquery $db dbTABLE_COUNT]
    loop i 0 $ntables {
	set db [lreplace $db 1 1 $i]
	lappend tables [dbquery $db dbTABLE_NAME]
    }

    set maxcol 10
    set i 0
 
    foreach table [lsort $tables] {
        set col [expr $i % $maxcol]
        set row [expr $i / $maxcol + 10 ]

        button $w.b$table \
            -text $table \
            -anchor w \
            -relief ridge \
            -command "dbtable $database $table"
 
        table $w $w.b$table  $row,$col -anchor e -fill x
        incr i
    }

    global Dbhelp Version Date
    button $w.apropos -text "Search for.." -command "apropos \"$db\""

    if { ! [info exists Dbhelp(is_dbhelp)] } {
	button $w.quit -text Dismiss -command "wm withdraw $w"
	table $w \
	    $w.apropos  25,0 -columnspan 3 -anchor w -fill x \
	    $w.quit 25,3 -columnspan 22 -fill x
    } else { 
	incr i -1
	button $w.quit -text Quit \
	    -bg red -fg white -activebackground red \
	    -command "destroy ."
	table $w \
	    $w.quit 25,24 -fill x

	button $w.about -text "About dbhelp" \
	    -command "about dbhelp $Version \"$Date\""
        table $w \
	    $w.apropos  25,0 -columnspan 3 -anchor w -fill x \
            $w.about 25,3 -columnspan 3 -fill x
    }
    wm resizable $w no no 
}


proc dbapropos { db pattern } { 

    set found ""
    set database [dbquery $db dbDATABASE_NAME]
    set ntables [dbquery $db dbTABLE_COUNT] 
    loop i 0 $ntables { 
	set db [lreplace $db 1 1 $i ] 
	set table [dbquery $db dbTABLE_NAME]
	if { [regexp $pattern [dbquery $db dbTABLE_DETAIL]] 
	    || [regexp $pattern [dbquery $db dbTABLE_DESCRIPTION]] } {
	    lappend found "dbtable $database $table" 
	}
	set nfields [dbquery $db dbFIELD_COUNT]
	loop j 0 $nfields {
	    set db [lreplace $db 2 2 $j ] 
	    set field [dbquery $db dbFIELD_NAME]
	    if { ! [info exists searched($field)] } { 
		set searched($field) 1
		if { [regexp $pattern [dbquery $db dbFIELD_DETAIL]] 
		    || [regexp $pattern [dbquery $db dbFIELD_DESCRIPTION]] } {
		    lappend found "dbfield $database $table $field" 
		    }
	    }
	}
    }
    return $found

}

proc apropos {db} {
    if { [winfo exists .w_apropos] } { raise .w_apropos ; return }
 
    set w .w_apropos
    toplevel $w
    wm title $w Apropos
    wm iconname $w Apropos

    label $w.l \
	-text "Search for"
    entry $w.entry \
	-width 60 \
	-relief sunken
    bind $w.entry <Enter> "focus $w.entry"
    bind $w.entry <Return> "$w.find invoke"

    set f $w.f
    frame $f

    button $w.find -text Find \
	-command "mkbuttons \"$db\" $w $f $w.entry"

    button $w.dismiss -text Dismiss -command "destroy $w"
    
    table $w \
	$w.l     0,0 -fill x \
	$w.entry 0,1 -columnspan 9 -fill x \
	$w.find  0,10 \
	$w.f     1,0 -columnspan 11 -fill x \
	$w.dismiss 100,0 -columnspan 11 -fill x 

}

proc mkbuttons { db w frame entry } {
    set pattern [$entry get]
    if { "$pattern" == "" } {
	bell 
    } else { 
	set slaves [winfo children $frame]
	if { "$slaves" != "" } { 
	    catch "table forget $slaves"
	    catch "destroy [set slaves]"
	}
	busy hold $w -cursor watch
	update idletasks
	set matches [dbapropos $db $pattern]
	busy release $w
	if { "$matches" == "" } { 
	    label $frame.l -text "No matches found"
	    table $frame \
		$frame.l 0,0 
	    bell
	} else { 
	    set cnt 0
	    set frow 0
	    set fcol 0
	    set trow 50
	    set tcol 0
	    set maxcol 10
	    foreach i $matches { 
		switch [lindex $i 0] {
		    dbtable {
			if { $tcol==0 && $trow==50 } {
			    label $frame.tablelabel -text Tables -fg blue
			    table $frame \
				$frame.tablelabel $trow,0 \
				    -columnspan 10 -fill x 
			    incr trow
			}

			set label [lindex $i 2]
			button $frame.b$cnt \
			    -text $label \
			    -command $i 
			table $frame \
			    $frame.b$cnt $trow,$tcol -fill x 
			incr cnt
			incr tcol
			if { $tcol > $maxcol } { 
			    set tcol 0
			    incr trow
			}
		    }

		    dbfield {
			if { $fcol == 0 && $frow == 0 } {
			    label $frame.fieldlabel -text Fields -fg blue
			    table $frame \
				$frame.fieldlabel $frow,0 \
				    -columnspan 10 -fill x 
			    incr frow
			}
			    
			set label [lindex $i 3]
			button $frame.b$cnt \
			    -text $label \
			    -command $i 
			table $frame \
			    $frame.b$cnt $frow,$fcol -fill x 
			incr cnt
			incr fcol
			if { $fcol > $maxcol } { 
			    set fcol 0
			    incr frow
			}
		    }
		}
	    }
	}
    }
}


# $Id: dbhelp.tcl,v 1.19 2004/04/15 15:21:06 danq Exp $ 
